#include "Windows.h"
#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include "conio.h"
#include "scripts.h"
#include "engine.h"
#include "Hooks.h"
#include "Console.h"
#include "gmfunc.h"

HANDLE new_screen = 0;
char Input[64];
int InputCount = 0;
int m_X = 0;
int m_Y = 0;

char *Lines[16];

struct Button
{
	int Position;
	int Width;
	char Name[32];
	bool MouseOver;
	bool Clicked;
	int Mode;
};
Button *Buttons[16];
int Console_Mode = 0;


void AddButton(const char *Name, int Mode)
{
	Button *b = new Button;
	memset(b, 0, sizeof(Button));

	strcpy(b->Name, Name);
	b->Mode = Mode;

	for(int i = 0; i < 16; i++)
	{
		if(!Buttons[i])
		{
			Buttons[i] = b;
			return;
		}
	}
}



unsigned short GetConsoleTextAttribute(HANDLE c)
{
  CONSOLE_SCREEN_BUFFER_INFO con_info;
  GetConsoleScreenBufferInfo(c, &con_info);
  return con_info.wAttributes;
}

inline unsigned short NumberToColour(char num, char num2)
{

	unsigned short ret = 0;
	if(num == 1)
	{
		ret = BACKGROUND_RED;
	}
	if(num == 2)
	{
		ret = BACKGROUND_GREEN;
	}
	if(num == 3)
	{
		ret = BACKGROUND_BLUE;
	}
	if(num == 4)
	{
		ret = BACKGROUND_RED | BACKGROUND_GREEN;
	}
	if(num == 5)
	{
		ret = BACKGROUND_RED | BACKGROUND_BLUE;
	}
	if(num == 6)
	{
		ret = BACKGROUND_GREEN | BACKGROUND_BLUE;
	}
	if(num == 7)
	{
		ret = BACKGROUND_RED | BACKGROUND_GREEN | BACKGROUND_BLUE;
	}

	if(num2 == 1)
	{
		ret |= FOREGROUND_RED;
	}
	if(num2 == 2)
	{
		ret |= FOREGROUND_GREEN;
	}
	if(num2 == 3)
	{
		ret |= FOREGROUND_BLUE;
	}
	if(num2 == 4)
	{
		ret |= FOREGROUND_RED | FOREGROUND_GREEN;
	}
	if(num2 == 5)
	{
		ret |= FOREGROUND_RED | FOREGROUND_BLUE;
	}
	if(num2 == 6)
	{
		ret |= FOREGROUND_GREEN | FOREGROUND_BLUE;
	}
	if(num2 == 7)
	{
		ret |= FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
	}
	ret |= FOREGROUND_INTENSITY;
	return ret;
}


int nPrintColour(const char *str)
{
	DWORD _len;
	
	unsigned short old = GetConsoleTextAttribute(new_screen);
	int ret = 0;
	for(const char *x = str; *x != 0; x++)
	{
		if(*x >= 8)
		{
			WriteConsole(new_screen, x, 1, &_len, 0);
			ret++;
		}
		else
		{
			char first = *(x++);
			unsigned short colour = NumberToColour(first, *(x));
			SetConsoleTextAttribute(new_screen, colour);
		}
	}
	
	SetConsoleTextAttribute(new_screen, old);
	return ret;
}


int nPrintf(const char *Format, ...)
{
	if(!new_screen)
	{
		return 0;
	}
	char buffer[256];
	va_list va;
	_crt_va_start(va, Format);
	vsnprintf(buffer, 256, Format, va);
	va_end(va);
	
	return nPrintColour(buffer);
}
int nPrintfAt(short x, short y, const char *Format, ...)
{
	if(!new_screen)
	{
		return 0;
	}
	char buffer[256];
	va_list va;
	_crt_va_start(va, Format);
	vsnprintf(buffer, 256, Format, va);
	va_end(va);
	CONSOLE_SCREEN_BUFFER_INFO ifo;
	GetConsoleScreenBufferInfo(new_screen, &ifo);

	if(x < 0)
	{
		x = ifo.dwSize.X+x;
	}
	if(y < 0)
	{
		y = 24+y;
	}
	COORD pos;
	pos.X = x;
	pos.Y = y;
	if(!SetConsoleCursorPosition(new_screen, pos))
	{
		nPrintf("Error: %d\n", GetLastError());
	}
	return nPrintColour(buffer);
}

void Console_Think()
{
	CONSOLE_SCREEN_BUFFER_INFO ifo;
	GetConsoleScreenBufferInfo(new_screen, &ifo);
	if(Console_Mode == 0) //output
	{
		for(short i = 0; i < 16; i++)
		{
			if(Lines[i])
			{
				nPrintfAt(0, i+4, "%s", Lines[i]);
			}
		}
	}
	else if(Console_Mode == 1) //players
	{
		short i = 4;
		for(GenericSLNode *x = PlayerList->HeadNode; x != 0; x = x->NodeNext)
		{
			cPlayer *p = (cPlayer *)x->NodeData;
			if(!p)
			{
				continue;
			}

			R_Assert(p);

			if(p->IsActive == 0 || p->IsInGame == 0 || p->PlayerType.Get() == 1)
			{
				continue;
			}

			GameObject *o = Get_GameObj(p->PlayerId);
			const wchar_t *preset = Get_Wide_Translated_Preset(o);
			const wchar_t *weapon = 0;
			GameObject *v = Get_Vehicle(o);
			weapon = Get_Wide_Translated_Preset(v ? v : o);
			R_Assert(preset);
			R_Assert(weapon);

			char tmp[256];
			sprintf(tmp, "%S (%S/%S)", (const wchar_t *)p->PlayerName, preset, weapon);
			nPrintfAt(0, i++, "%c%c%-50s %.1-6f%%", 3, 1, tmp, ((Commands->Get_Health(o)+Commands->Get_Shield_Strength(o)) / (Commands->Get_Max_Health(o)+Commands->Get_Max_Shield_Strength(o)))*100);
			delete []preset;
			delete []weapon;
		}

		if(i > 4)
		{
			i++;
		}

		for(GenericSLNode *x = PlayerList->HeadNode; x != 0; x = x->NodeNext)
		{
			cPlayer *p = (cPlayer *)x->NodeData;
			if(!p)
			{
				continue;
			}

			if(p->IsActive == 0 || p->IsInGame == 0 || p->PlayerType.Get() == 0l)
			{
				continue;
			}

			GameObject *o = Get_GameObj(p->PlayerId);
			const wchar_t *preset = Get_Wide_Translated_Preset(o);
			const wchar_t *weapon = 0;
			GameObject *v = Get_Vehicle(o);
			weapon = Get_Wide_Translated_Preset(v ? v : o);

			R_Assert(preset);
			R_Assert(weapon);

			char tmp[256];
			sprintf(tmp, "%S (%S/%S)", (const wchar_t *)p->PlayerName, preset, weapon);
			nPrintfAt(0, i++, "%c%c%-50s %.1f%%", 3, 4, tmp, ((Commands->Get_Health(o)+Commands->Get_Shield_Strength(o)) / (Commands->Get_Max_Health(o)+Commands->Get_Max_Shield_Strength(o)))*100);
			delete []preset;
			delete []weapon;
		}
		if(i == 4)
		{
			nPrintfAt(0, 4, "There are no players.");
			i++;
		}
		Clear_After((short)i);
	}
	else if(Console_Mode == 2) //vehicles
	{
		short i = 4;
		for(GenericSLNode *x = SmartGameObjList->HeadNode; x != 0; x = x->NodeNext)
		{
			if(!x)
			{
				continue;
			}
			GameObject *o = As_VehicleGameObj((GameObject *)x->NodeData);
			o = Get_Vehicle_Mode(o) == TURRET ? 0 : o;
			if(!o)
			{
				continue;
			}

			char colour = 1;
			if(Get_Object_Type(o) == 1)
			{
				colour = 4;
			}
			else if(Get_Object_Type(o) != 0)
			{
				colour = 7;
			}
			nPrintfAt(0, i++, "%c%c%-32s %.1f%%", 3, colour, Commands->Get_Preset_Name(o), ((Commands->Get_Health(o)+Commands->Get_Shield_Strength(o)) / (Commands->Get_Max_Health(o)+Commands->Get_Max_Shield_Strength(o)))*100);
		}
		if(i == 4)
		{
			nPrintfAt(0, 4, "There are no vehicles.");
		}
	}
	else if(Console_Mode == 3) //buildings
	{
		short i = 4;
		for(GenericSLNode *x = BuildingGameObjList->HeadNode; x != 0; x = x->NodeNext)
		{
			if(!x)
			{
				continue;
			}
			GameObject *o = As_BuildingGameObj((GameObject *)x->NodeData);
			if(!o)
			{
				continue;
			}

			if(Get_Object_Type(o) == 1)
			{
				nPrintfAt(0, i++, "%c%c%-32s %.1f%%", 3, 4, Commands->Get_Preset_Name(o), ((Commands->Get_Health(o)+Commands->Get_Shield_Strength(o)) / (Commands->Get_Max_Health(o)+Commands->Get_Max_Shield_Strength(o)))*100);
			}
		}
		if(i == 4)
		{
			nPrintfAt(0, 4, "%c%cThere are no GDI buildings.", 3, 4);
		}
		short tmp = i;
		if(i > 4)
		{
			i++;
		}
		for(GenericSLNode *x = BuildingGameObjList->HeadNode; x != 0; x = x->NodeNext)
		{
			if(!x)
			{
				continue;
			}
			GameObject *o = As_BuildingGameObj((GameObject *)x->NodeData);
			if(!o)
			{
				continue;
			}

			if(Get_Object_Type(o) == 0)
			{
				nPrintfAt(0, i++, "%c%c%-32s %.1f%%", 3, 1, Commands->Get_Preset_Name(o), ((Commands->Get_Health(o)+Commands->Get_Shield_Strength(o)) / (Commands->Get_Max_Health(o)+Commands->Get_Max_Shield_Strength(o)))*100);
			}
		}
		if(tmp+1 == i)
		{
			nPrintfAt(0, 4, "%c%cThere are no Nod buildings.", 3, 1);
		}	
	}
	else if(Console_Mode == 4) //options
	{
		const char *str = "Options";

		COORD pos;
		pos.X = short((ifo.dwSize.X/2)-(strlen(str)/2));
		pos.Y = 4;
		R_Assert(SetConsoleCursorPosition(new_screen, pos));

		nPrintf("%s", str);

		nPrintfAt(0, 6, "%-24s", "TimeStamps");
		nPrintfAt(24, 6, "%s[%s]", "\x07\x08", C_Settings::TimeStamps == 0 ? " " : "X");
		nPrintfAt(0, 7, "%-24s", "TimeStamp");
		nPrintfAt(24, 7, "%s%s%-*s", "\x07\x08", C_Settings::TimeStamp_tmp, 35-strlen(C_Settings::TimeStamp_tmp), "\x03\x08");

		nPrintfAt(0, 8, "%-24s", "ShowLevelLoad");
		nPrintfAt(24, 8, "%s[%s]", "\x07\x08", C_Settings::ShowLevelLoad == 0 ? " " : "X");
		nPrintfAt(0, 9, "%-24s", "ShowLevelEnd");
		nPrintfAt(24, 9, "%s[%s]", "\x07\x08", C_Settings::ShowLevelEnd == 0 ? " " : "X");
		nPrintfAt(0, 10, "%-24s", "ShowPlayerJoin");
		nPrintfAt(24, 10, "%s[%s]", "\x07\x08", C_Settings::ShowPlayerJoin == 0 ? " " : "X");
		nPrintfAt(0, 11, "%-24s", "ShowPlayerLeave");
		nPrintfAt(24, 11, "%s[%s]", "\x07\x08", C_Settings::ShowPlayerLeave == 0 ? " " : "X");
	}

	if(_kbhit() != 0)
	{
		Input_Add_Char((char)_getch());
	}

	DWORD cNumRead;
	INPUT_RECORD irInBuf[128]; 
	if(PeekConsoleInput(GetStdHandle(STD_INPUT_HANDLE), irInBuf, 128, &cNumRead))
	{
		if(cNumRead != 0)
		{
			ReadConsoleInput(GetStdHandle(STD_INPUT_HANDLE), irInBuf, 128, &cNumRead);
		}
		else
		{	
			return;
		}
	}
	else
	{
		return;
	}



	for (unsigned int i = 0; i < cNumRead; i++) 
	{
		 if(irInBuf[i].EventType == MOUSE_EVENT)
		{
			m_X = irInBuf[i].Event.MouseEvent.dwMousePosition.X;
			m_Y = irInBuf[i].Event.MouseEvent.dwMousePosition.Y;
			if(irInBuf[i].Event.MouseEvent.dwEventFlags == DOUBLE_CLICK)
			{
				if(Console_Mode == 4)
				{
					if(m_X >= 23 && m_X <= 26 && m_Y == 6)
					{
						C_Settings::TimeStamps = C_Settings::TimeStamps ? 0 : 1;
					}
					if(m_X >= 23 && m_X <= 26 && m_Y == 8)
					{
						C_Settings::ShowLevelLoad = C_Settings::ShowLevelLoad ? 0 : 1;
					}
					if(m_X >= 23 && m_X <= 26 && m_Y == 9)
					{
						C_Settings::ShowLevelEnd = C_Settings::ShowLevelEnd ? 0 : 1;
					}
					if(m_X >= 23 && m_X <= 26 && m_Y == 10)
					{
						C_Settings::ShowPlayerJoin = C_Settings::ShowPlayerJoin ? 0 : 1;
					}
					if(m_X >= 23 && m_X <= 26 && m_Y == 11)
					{
						C_Settings::ShowPlayerLeave = C_Settings::ShowPlayerLeave ? 0 : 1;
					}
				}
				for(int i = 0; i < 16; i++)
				{
					Button *b = Buttons[i];
					if(b)
					{
						if(m_Y == 1 && (m_X > b->Position && m_X < b->Position+b->Width) && !b->Clicked)
						{
							b->MouseOver = 1;
							b->Clicked = 1;
							if(Console_Mode == 4 && b->Mode != 4)
							{
								WritePrivateProfileString("Options", "TimeStamps", C_Settings::TimeStamps ? "1" : "0", C_Settings::ini);
								WritePrivateProfileString("Options", "ShowLevelLoad", C_Settings::ShowLevelLoad ? "1" : "0", C_Settings::ini);
								WritePrivateProfileString("Options", "ShowLevelEnd", C_Settings::ShowLevelEnd ? "1" : "0", C_Settings::ini);
								WritePrivateProfileString("Options", "ShowPlayerJoin", C_Settings::ShowPlayerJoin ? "1" : "0", C_Settings::ini);
								WritePrivateProfileString("Options", "ShowPlayerLeave", C_Settings::ShowPlayerLeave ? "1" : "0", C_Settings::ini);
								WritePrivateProfileString("Options", "TimeStamp", C_Settings::TimeStamp_tmp, C_Settings::ini);
								strcpy(C_Settings::TimeStamp, C_Settings::TimeStamp_tmp);
							}
							Console_Mode = b->Mode;
							Clear_Screen();
							for(int y = 0; y < 16; y++)
							{
								if(Buttons[y] != b && Buttons[y] != 0)
								{
									if(Buttons[y]->Clicked)
									{
										nPrintfAt((short)Buttons[y]->Position, 1, "%c%c%s", 7, 8, Buttons[y]->Name);
									}
									
									Buttons[y]->Clicked = 0;
								}
							}
							nPrintfAt((short)Buttons[i]->Position, 1, "%c%c%s", 1, 8, Buttons[i]->Name);
						}
					}
				}
			}
		}
	}	

	for(int i = 0; i < 16; i++)
	{
		Button *b = Buttons[i];
		if(b)
		{
			if(b->MouseOver)
			{
				if((m_Y != 1 || m_X < b->Position || m_X > b->Position+b->Width) && !b->Clicked)
				{
					b->MouseOver = 0;
					nPrintfAt((short)b->Position, 1, "%c%c%s", 7, 8, Buttons[i]->Name);
				}
			}
			else
			{
				if(m_Y == 1 && (m_X > b->Position && m_X < b->Position+b->Width))
				{
					b->MouseOver = 1;
					nPrintfAt((short)b->Position, 1, "%c%c%s", 1, 8, Buttons[i]->Name);
				}
			}
		}
	}
}

void Start()
{
	C_Settings::Load();
	memset(Input, 0, 64);
	new_screen = CreateConsoleScreenBuffer(GENERIC_WRITE|GENERIC_READ, FILE_SHARE_WRITE|FILE_SHARE_READ, 0, CONSOLE_TEXTMODE_BUFFER, 0);
	R_Assert(new_screen);

	SetConsoleMode(new_screen, ENABLE_MOUSE_INPUT);

	
	R_Assert(SetConsoleActiveScreenBuffer(new_screen));

	memset((void *)Lines, 0, 4*16);
	const char *str = "RenGooey";

	CONSOLE_SCREEN_BUFFER_INFO ifo;
	GetConsoleScreenBufferInfo(new_screen, &ifo);

	COORD pos;
	pos.X = short((ifo.dwSize.X/2)-(strlen(str)/2));
	pos.Y = 0;
	R_Assert(SetConsoleCursorPosition(new_screen, pos));

	nPrintf("%s", str);

	pos.X = 0;
	pos.Y = 2;
	R_Assert(SetConsoleCursorPosition(new_screen, pos));

	for(int i = 0; i < ifo.dwSize.X; i++)
	{
		nPrintf("-");
	}

	pos.X = 0;
	pos.Y = 22;
	R_Assert(SetConsoleCursorPosition(new_screen, pos));
	for(int i = 0; i < ifo.dwSize.X; i++)
	{
		nPrintf("-");
	}

	memset(Buttons, 0, 16*4);

	AddButton("Output", 0);
	AddButton("Players", 1);
	AddButton("Vehicles", 2);
	AddButton("Buildings", 3);
	AddButton("Options", 4);

	int _x = 0;
	for(int i = 0; i < 16; i++)
	{
		if(Buttons[i])
		{
			_x += 1;
			Buttons[i]->Position = _x;
			Buttons[i]->Width = strlen(Buttons[i]->Name);
			_x += nPrintfAt((short)_x, 1, "%c%c%s", 7, 8, Buttons[i]->Name);
		}
	}
}

void AddLine(const char *Format, ...)
{
	char buffer[256];
	*buffer = 0;

	if(C_Settings::TimeStamps)
	{
		time_t t = time(0);
		struct tm * timeinfo = localtime (&t);
		strftime(buffer, 32, C_Settings::TimeStamp, timeinfo);
	}
	strcat(buffer, " ");
	va_list va;
	_crt_va_start(va, Format);
	int len = strlen(buffer);
	vsnprintf(buffer+len, 256-len, Format, va);
	va_end(va);


	for(int i = 0; i < 16; i++)
	{
		if(Lines[i] == 0)
		{
			Lines[i] = strdup(buffer);
			return;
		}
	}
	free((void *)*Lines);

	memcpy(Lines, Lines+1, 15*4);
	Lines[15] = strdup(buffer);
}

void Input_Add_Char(char c)
{
	if(Console_Mode == 4)
	{
		int len = strlen(C_Settings::TimeStamp_tmp);
		
		if(c == 8)
		{
			if(len == 0)
			{
				return;
			}
			C_Settings::TimeStamp_tmp[len-1] = 0;
		}
		else
		{
			if(len > 32)
			{
				return;
			}
			char cat[2];
			cat[0] = c;
			cat[1] = 0;
			strcat(C_Settings::TimeStamp_tmp, cat);
		}
		return;
	}
	if(c == 8)
	{
		if(InputCount == 0)
		{
			nPrintfAt(1, 23, "%-64s", Input);
			return;
		}
		Input[(InputCount--)-1] = 0;
		nPrintfAt(1, 23, "%-64s", Input);
		return;
	}
	if(InputCount >= 62 && c != 13)
	{
		nPrintfAt(1, 23, "%-64s", Input);
		return;
	}
	if(c == 13)
	{
		Console_Input(Input);

		InputCount = 0;
		memset(Input, 0, 64);

		nPrintfAt(1, 23, "%-64s", "");
		return;
	}

	Input[InputCount++] = c;
	nPrintfAt(1, 23, "%-64s", Input);
}

void Clear_Screen()
{
	CONSOLE_SCREEN_BUFFER_INFO ifo;
	GetConsoleScreenBufferInfo(new_screen, &ifo);
	for(short i = 4; i < 22; i++)
	{
		nPrintfAt(0, i, "%*s", ifo.dwSize.X, " ");
	}
}

inline void Clear_After(short used)
{
	CONSOLE_SCREEN_BUFFER_INFO ifo;
	GetConsoleScreenBufferInfo(new_screen, &ifo);
	for(short i = used; i < 22; i++)
	{
		nPrintfAt(0, i, "%*s", ifo.dwSize.X, " ");
	}
}



char C_Settings::TimeStamp[64];
char C_Settings::TimeStamp_tmp[64];

bool C_Settings::TimeStamps;
bool C_Settings::ShowLevelLoad;
bool C_Settings::ShowLevelEnd;
bool C_Settings::ShowPlayerJoin;
bool C_Settings::ShowPlayerLeave;

char C_Settings::ini[256];

void C_Settings::Load()
{
	char buffer[256];
	for(int i = GetModuleFileName(0, buffer, 256); i >= 0; i--)
	{
		if(buffer[i] == '\\')
		{
			buffer[i] = 0;
			break;
		}
	}
	strcat(buffer, "\\RenGooey.ini");
	strcpy(C_Settings::ini, buffer);
	INIClass *ini = Get_INI(buffer);
	if(!ini)
	{
		MessageBox(0, "Error loading RenGooey.ini", "Error", MB_OK);
		ExitProcess(0);
	}

	ini->Get_String("Options", "TimeStamp", "", TimeStamp, 64);
	strcpy(TimeStamp_tmp, TimeStamp);

	TimeStamps = ini->Get_Bool("Options", "TimeStamps", 0);
	ShowLevelLoad = ini->Get_Bool("Options", "ShowLevelLoad", 1);
	ShowLevelEnd = ini->Get_Bool("Options", "ShowLevelEnd", 1);
	ShowPlayerJoin = ini->Get_Bool("Options", "ShowPlayerJoin", 1);
	ShowPlayerLeave = ini->Get_Bool("Options", "ShowPlayerLeave", 1);

	Release_INI(ini);
	ini = 0;
}


void Get_Object_Info(GameObject *o, char *buffer)
{
	if(Commands->Is_A_Star(o))
	{
		const wchar_t *preset = Get_Wide_Translated_Preset(o);
		const wchar_t *weapon = 0;
		GameObject *v = Get_Vehicle(o);
		weapon = Get_Wide_Translated_Preset(v ? v : o);

		R_Assert(preset);
		R_Assert(weapon);

		sprintf(buffer, "%S (%S/%S)", Get_Wide_Player_Name(o), preset, weapon);

		delete []preset;
		delete []weapon;
	}
	else
	{
		const wchar_t *p = Get_Wide_Translated_Preset(o);
		sprintf(buffer, "%S", p);
		delete []p;
	}
}

