/*	Renegade Scripts.dll
	Example Plugin Code
	Copyright 2007 Whitedragon(MDB), Jonathan Wilson

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/

#include "conio.h"
#include "scripts.h"
#include <stdarg.h>
#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#include "engine.h"
#include "gmmain.h"
#include "plugin.h"
#include "Hooks.h"
#include "Console.h"

int ConsoleCommandPrintf(const char *Format, ...)
{
	char buffer[256];
	va_list va;
	_crt_va_start(va, Format);
	vsnprintf(buffer, 256, Format, va);
	va_end(va);

	AddLine(buffer);
	return 0;
}

__declspec(naked) void ConsoleCommandPrintf_Glue()
{
	__asm
	{
		jmp ConsoleCommandPrintf;
	}
}



bool Suicide_Hook(int PlayerID)
{
	char colour = 1;
	if(Get_Team(PlayerID) == 1)
	{
		colour = 4;
	}
	else if(Get_Team(PlayerID) != 0)
	{
		colour = 7;
	}


	AddLine("%c%c%S committed suicide.", 3, colour, Get_Wide_Player_Name_By_ID(PlayerID));
	return 1;
}

void Serial_Hook(int PlayerID, const char *Serial)
{
	AddLine("%S's serial hash is: %s", Get_Wide_Player_Name_By_ID(PlayerID), Serial);
}

bool Chat_Hook(int PlayerID, int Type, WideStringClass &Message, int Target)
{
	char tmp[256];
	wcstombs(tmp, (const wchar_t *)Message, 256);
	if(strchr(tmp, '\n'))
	{
		return 1;
	}


	char colour = 1;
	if(Get_Team(PlayerID) == 1)
	{
		colour = 4;
	}
	else if(Get_Team(PlayerID) != 0)
	{
		colour = 7;
	}

	if(Type == 0)
	{
		AddLine("%c%c%S: %c%c%S", 3, colour, Get_Wide_Player_Name_By_ID(PlayerID), 3, 7,  (const wchar_t *)Message); 
	}
	else if(Type == 1)
	{
		AddLine("%c%c[Team] %S: %S", 3, colour, Get_Wide_Player_Name_By_ID(PlayerID),  (const wchar_t *)Message); 
	}
	else if(Type == 2)
	{
		char colour2 = 1;
		if(Get_Team(Target) == 1)
		{
			colour2 = 4;
		}
		else if(Get_Team(Target) != 0)
		{
			colour2 = 7;
		}
		AddLine("%c%c[Private] %S --> %c%c%S%c%c: %S", 3, colour, Get_Wide_Player_Name_By_ID(PlayerID), 3, colour2, Get_Wide_Player_Name_By_ID(Target), 3, colour,  (const wchar_t *)Message); 
	}
	return 1;
}

void Think_Hook()
{
	Console_Think();
}


void Plugin_Load() 
{
	Load_Hooks();

	AddChatEHook(Chat_Hook);
	AddSerialHook(Serial_Hook);
	AddThinkHook(Think_Hook);
	AddSuicideHook(Suicide_Hook);
	Start();

	call_hook((void *)ConsoleCommandPrintf_Glue, (int)0x428CD0);
}



void Plugin_Unload() 
{

}

extern "C" 
{


DLLEXPORT void SSGM_Host_Hook(int ID, int Type, const char *Msg) 
{
	if(Type == 0)
	{
		AddLine("%c%cHost: %s", 3, 7, Msg);
	}
}

DLLEXPORT void SSGM_Player_Join_Hook(int ID, const char *Nick) 
{
	if(!C_Settings::ShowPlayerJoin)
	{
		return;
	}
	StringClass tmp;
	RequestSerial(ID, tmp);
	AddLine("%s has joined the game, fighting for team %c%c%S", Nick, 3, Get_Team(ID) == 1 ? 4 : 1, Get_Wide_Team_Name(Get_Team(ID)));
}

DLLEXPORT void SSGM_Player_Leave_Hook(int ID) 
{
	if(!C_Settings::ShowPlayerLeave)
	{
		return;
	}
	AddLine("%c%c%S has left the game.", 3, Get_Team(ID) == 1 ? 4 : 1, Get_Wide_Player_Name_By_ID(ID));
}

char LastMap[256];
DLLEXPORT void SSGM_Level_Loaded_Hook() 
{
	if(!C_Settings::ShowLevelLoad)
	{
		return;
	}
	strcpy(LastMap, The_Game()->MapName);
	AddLine("%c%cLevel %s has loaded.", 3, 2, LastMap);
}

DLLEXPORT void SSGM_GameOver_Hook() 
{
	if(!C_Settings::ShowLevelEnd)
	{
		return;
	}
	AddLine("%c%cLevel %s has ended, next map will be %s", 3, 2, LastMap, The_Game()->MapName);
}

}

void call_hook(void *hook, int address)
{
	char buffer[5];
	int s = (int)hook - address - 5;
	*buffer = '\xE9';
	memcpy(buffer+1, (void *)&s, 4);

	unsigned long stub;
	HANDLE p = OpenProcess(PROCESS_ALL_ACCESS, false, GetCurrentProcessId());
	VirtualProtectEx(p, (LPVOID)address, 5, 0x40, &stub);
	WriteProcessMemory(p, (LPVOID)address, buffer, 5, 0);
	VirtualProtectEx(p, (LPVOID)address, 5, stub, 0);
	CloseHandle(p);
}
inline int Get_Colour(GameObject *o)
{
	char colour = 1;
	if(Get_Object_Type(o) == 1)
	{
		colour = 4;
	}
	else if(Get_Object_Type(o) != 0)
	{
		colour = 7;
	}
	return colour;
}